# --- list.tcl --- Demonstration of a linked list implementation

# Copyright(C) I.B.Findleton, 2001. All Rights Reserved

package require Containers

# Create a template to hold the list element data

set t [struct Name Address Phone Next]

puts "Structure Elements ... [$t -elements]"

# Initialize a few instances of the template. Note that the
# link element in Next needs to be something other than the 
# token that identifies the linked structure, otherwise, the
# extension assumes an initialization from inheritance.

set i [$t Iain "Baie D'Urfe" 457-0744]
set r [$t Ross "Valois" 695-4022 &$i]
set a [$t Ashley "Westmount" 935-8148 &$r]

puts "Elements of i ... [$i -elements]"
puts "Elements of r ... [$r -elements]"
puts "Elements of a ... [$a -elements]"

# This proc just gets the name of an instance from the pointer

proc Next { this } {

	return [string range [$this Next] 1 end]
	}

# Cycle through the linked list

puts "Linked list...\n"

set this $a
while { $this != "" } {
	puts "[$this Name] [$this Address] [$this Phone]"
	set this [Next $this]
	}





